Hooks:PostHook(PlayerStandard,"init","init_medicmain",function(self, ...)
	MedicMain.doc_bag_uses = 0
end)

function clog(message)
	if false then
		managers.chat:send_message(ChatManager.GAME, managers.network.account:username() or "Offline", tostring(message))
	end
end

_orig_get_intimidation_action = PlayerStandard._get_intimidation_action
function PlayerStandard:_get_intimidation_action(prime_target, char_table, amount, primary_only, detect_only, secondary)
	if MedicMain:IsEnabled() then
		if MedicMain:IsActive() then
			if prime_target then
				if prime_target.unit_type == 2 then
					local is_human_player, record = nil
					if not detect_only then --todo make this check before prime_target so that it gives the right hint
						record = managers.groupai:state():all_criminals()[prime_target.unit:key()]
						if not record.ai then --record and not record.ai then 
							is_human_player = true
							
							
								local is_arrested,needs_revive = nil
								
							if prime_target.unit:base().is_husk_player then
								if prime_target.unit:movement():current_state_name() == "arrested" or prime_target.unit:interaction():active() and prime_target.unit:movement():need_revive() and not is_arrested then
								--if arrested or needs revive
									managers.hud:show_hint({text = "Help this player up before healing them!"})
									return							
								end --maybe you should be able to consume a FAK/docbag charge to revive them instantly? iunno
							end
							clog( "Distance to target is " .. tostring(mvector3.distance_sq(self._pos, record.m_pos)) )							

							if mvector3.distance_sq(self._pos, record.m_pos) > MedicMain.max_heal_distance then --todo make this distance longer with crew chief?
								managers.hud:show_hint({text = "You are too far away to heal this person!"})
								return
							end
							
							
--this thing doesn't work either i guess
							local full_health = false --prime_target.unit:character_damage().health == prime_target.unit:character_damage().max_health
							--todo make this thingy work
--							log("Target health is " .. prime_target.unit:character_damage().health .. "/" .. prime_target.unit:character_damage().max_health)
							if not full_health then 
								equip = managers.player:selected_equipment_id()
								target_peerid = managers.criminals:character_peer_id_by_unit(prime_target.unit)
								clog("Heal target_peerid is player " .. tostring(target_peerid))
								if not MedicMain.players[tostring(target_peerid)] then
									managers.hud:show_hint({text = "Heal target doesn't have this mod!"})
									LuaNetworking:SendToPeer(target_peerid,MedicMain.ModID, "I tried to heal you, but you don't have MedicMain mod :(")
									--^ just in case player was not on the opt-in list
									return
								end
							
								if managers.player:has_deployable_left(equip) then
									local upgrade_lvl = tostring(managers.player:upgrade_level("first_aid_kit", "damage_reduction_upgrade"))
									local amount_upgrade_lvl = tostring(managers.player:upgrade_level("doctor_bag", "amount_increase"))
									
									local downs_reset = "false"
									
									if equip == "first_aid_kit" then
										-- downs_reset = "false"
										managers.player:remove_equipment(equip)
									elseif equip == "doctor_bag" then

										max_uses = 2 + managers.player:upgrade_level("doctor_bag", "amount_increase")
--										log("MedicMain: max_uses for doc bags is " .. tostring(max_uses))
										MedicMain.doc_bag_uses = (MedicMain.doc_bag_uses and MedicMain.doc_bag_uses + 1) or 0
										
										if MedicMain.doc_bag_uses >= max_uses then
--											log("Used up a whole doc bag. Removing 1 docbag and resetting...")
											MedicMain.doc_bag_uses = 0
											managers.player:remove_equipment(equip)
										end
										downs_reset = "true"
									end
--									log(tostring(target_peerid) .. ":_" .. MedicMain.ModID .. "_Healed:" .. upgrade_lvl .. ":" .. amount_upgrade_lvl .. ":" .. downs_reset)
									LuaNetworking:SendToPeer(target_peerid,MedicMain.ModID, "Healed:" .. upgrade_lvl .. ":" .. amount_upgrade_lvl .. ":" .. downs_reset )
									managers.player:local_player():movement():current_state():_play_distance_interact_redirect(0, "use") --or cmd_get_up
									
									if Utils:IsInHeist() and Utils:IsInCustody() == false and Utils:IsInGameState() then 
										managers.player:local_player():sound():say("s08x_sin",true,true) --"i'm helping you up"
									end
								
								end
							else
								managers.hud:show_hint({text = "Heal target is at full health!"})
							end
						else
							managers.hud:show_hint({text = "Can't heal NPCs!"})
--							log("MedicMain: Failure. Target is AI or not criminal!")
						end
					else
						managers.hud:show_hint({text = "Healing bullet wounds is a suspicious action..."})
--						log("MedicMain: Failure. Can only be used in loud.")
					end
				else
					managers.hud:show_hint({text = "Heal target is not a Criminal!"})
--					log("MedicMain: Failure. unit_type is not teammate.")
				end
			elseif not prime_target then
				managers.hud:show_hint({text = "No heal target."})
--				log("MedicMain: Failure. invalid prime_target!")
			end
		else
--			log("MedicMain: Failure. Filter key is not pressed!")
			return _orig_get_intimidation_action(self, prime_target, char_table, amount, primary_only, detect_only, secondary)
		end
	else
		return _orig_get_intimidation_action(self, prime_target, char_table, amount, primary_only, detect_only, secondary)
	end
end



--[[
some anims: (playerstandard.anim_states)

cmd_come
cmd_stop
cmd_point
cmd_down
cmd_get_up
cmd_gogo
--]]	
